<?php
/**
 * @package Plugin TDGoogleAnalytics for Joomla!
 * @version		$Id: tdgoogleanalytics.php 2 2009-07-02 19:54:38Z deh $
 * @author Tim Dehnert
 * @copyright (C) 2010 - Tim Dehnert
 * @license GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
 

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.plugin.plugin');

class plgSystemTDgoogleanalytics extends JPlugin
{
	function plgSystemTDgoogleanalytics(&$subject, $config)
	{
		parent::__construct($subject, $config);		
	}
	
	function onAfterRender()
	{
		
		$app = JFactory::getApplication();
		$document = JFactory::getDocument();
		
		//init with default values
		$web_property_id_default = trim($this->params->get( 'default_web_property_id', '' ));
		$web_property_id_final = $web_property_id_default;
		$web_property_id_domain='';
		$web_property_id_language='';
		$debug = '';
		$debuginfo='<h6>TD Google Analytics (Plugin)</h6><hr/>';
		$debuginfo.='Document Language: '.$document->getLanguage().'<br/>';
		if ($app->isSite()) {
		$debuginfo.='Document Area: Site<br/>';
		}
		else if ($app->isAdmin()) {
		$debuginfo.='Document Area: Admin<br/>';
		}
		else {
		$debuginfo.='Document Area: Unknown<br/>';
		}
		
		
		$google_analytics_javascript='';
		
		$url = strtolower($_SERVER["SERVER_NAME"]);
		
		$debuginfo.='Document URL: '.$url.'<br/>';
		$debuginfo.='Default Web Property ID: '.$web_property_id_default.'<br/>';
		$overridepriority=trim($this->params->get( 'overridepriority', '' ));
		if ($overridepriority == 0) {
		$debuginfo.='Override Priority is Domain/IP<br/>';
		}
		else {
		$debuginfo.='Override Priority is Language<br/>';
		}
		
		$multikey = trim($this->params->get( 'web_property_ids_domain', '' ));
			if ($multikey!='') {				
				$replace = array("\n", "\r", "<br/>", "<br />", "<br>");
				$sites = preg_split("/[\n\r]+/", $multikey);
				foreach($sites as $site)
				{
					$values = explode("=",$site, 2);
					$values[0] = strtolower(trim(str_replace($replace, '', $values[0])));
					$values[1] = str_replace($replace, '', $values[1]);									
					if ($url==$values[0] || '*'==$values[0])
					{
						$web_property_id_domain = trim($values[1]);
						$web_property_id_final = trim($values[1]);
						if ( $values[0] != '*') {
							break;
						}
					}
				}
			}
		if ($web_property_id_final != $web_property_id_default) {
		$debuginfo.='Default Web Property ID overriden based on Domain/IP with '.$web_property_id_final.'<br/>';
		}
		else {
		$debuginfo.='No override information based on Domain/IP found<br/>';
		}
		
		if ($overridepriority=='1') {
		$lang=strtolower($document->getLanguage());
		
		$multikey = trim($this->params->get( 'web_property_ids_language', '' ));
			if ($multikey!='') {				
				$replace = array("\n", "\r", "<br/>", "<br />", "<br>");
				$sites = preg_split("/[\n\r]+/", $multikey);
				foreach($sites as $site)
				{
					$values = explode("=",$site, 2);
					$values[0] = strtolower(trim(str_replace($replace, '', $values[0])));
					$values[1] = str_replace($replace, '', $values[1]);									
					if ($lang==$values[0] || '*'==$values[0])
					{	
						$web_property_id_language = trim($values[1]);
						$web_property_id_final = trim($values[1]);
						if ( $values[0] != '*') {
							break;
						}
					}
				}
			}		
		}
		if ($web_property_id_final != $web_property_id_default && $web_property_id_final!=$web_property_id_domain) {
		$debuginfo.='Default Web Property ID overriden based on Language with '.$web_property_id_final.'<br/>';
		}
		else {
		$debuginfo.='No override information based on Language found<br/>';
		}
		
		if(empty($web_property_id_final)) 	{
		$debuginfo=$debuginfo.'Web Property Id not found!<br/>';
		}
		else {
			if($app->isSite()) {
		$debuginfo=$debuginfo.'Google Analytics Tracking Code (Web Property ID: '.$web_property_id_final.') inserted.<br/>';		
		}
		else {
		$debuginfo=$debuginfo.'Web Property ID '.$web_property_id_final.' found. Google Analytics Tracking Code will not inserted on admin site.<br/>';		
		}
		}
		
		
		if(JDEBUG) {
				
				$debug = '<pre style="background:white; color: black; border: thick solid red; margin: 2em;">'.$debuginfo.'</pre>';
			}
		
		if(!empty($web_property_id_final) && $app->isSite())
		{
		
		
		
		$google_analytics_javascript = '
			<script type="text/javascript">
			var gaJsHost = (("https:" == document.location.protocol) ? "https://ssl." : "http://www.");
			document.write(unescape("%3Cscript src=\'" + gaJsHost + "google-analytics.com/ga.js\' type=\'text/javascript\'%3E%3C/script%3E"));
			</script>
			<script type="text/javascript">
			try {
			var pageTracker = _gat._getTracker("'.$web_property_id_final.'");
			pageTracker._trackPageview();
			} catch(err) {}</script>
			';
		}
		if(empty($google_analytics_javascript) && empty($debug)) return;

    $buffer = JResponse::getBody();


		$pos = strrpos($buffer, "</body>");
		
		if($pos > 0)
		{
			$buffer = substr($buffer, 0, $pos).$debug.$google_analytics_javascript.substr($buffer, $pos);

			JResponse::setBody($buffer);
		}
		
		
		
		return true;
	}
}
?>